{
   ProbBusTest3: buffer exchange between BC and RT with auto cycle off and async command
}

CON
  _CLKMODE = XTAL1 + PLL16X   'Setting up the clock mode
  _XINFREQ = 5_000_000        'Setting up the' frequency
                                                                                 
  CR = 13  ''NL: New Line        
  LF = 10  ''LF: Line Feed    


OBJ

  pst   : "Parallax Serial Terminal"
  bc    : "PropBusBC"
  rt    : "PropBusRT" 
  
VAR
           
  long NEWLINE[3]


CON

  BUF_SIZE     = 63
  CYCLE_FREQ   = 10 ' 60 ' 1000 ' debug
  MSG_COUNT    =  0 ' 2
  BUS_BIT_RATE = 300_000 '1_100_000   ' debug

  VALID_DELAY  = 5 ' delay until buffer values are valid
  
VAR

  word  RTBuf[BUF_SIZE], IncrBuf[BUF_SIZE], RTCmnd
  word  BCBuf1[BUF_SIZE], BCBuf2[BUF_SIZE], BCBuf3[BUF_SIZE], BCBuf4[BUF_SIZE], BCBuf5[BUF_SIZE], BCBuf6[BUF_SIZE]

 

PUB Main

  NEWLINE[0]:=CR                ' setup NEWLINE string
  NEWLINE[1]:=LF
  NEWLINE[2]:=0

 waitcnt(clkfreq*5 + cnt) '5 sec debug for start serial terminal 

  
  if ina[0]==1   ' BCs
     
     dira[11]~~               ' P11 output
     outa[11]~                ' P11 lo fr c1      
               
     dira[1]~~                ' P1 output
     outa[1]~~                ' p1 hi = c1 boot
          
     repeat
     while  ina[10] > 0

     dira[11]~                ' P11 input
     outa[11]~                ' P11 lo     
     
     startBC
     execRemote
     
     repeat 
               
  else           ' RTs
     
     startRT   
     dira[10]~~   ' Pin 15
     outa[10]~    ' lo                    
     execRT 
      
    repeat      


pri execRemote | exI, exSum, exRnd

      pst.start(115200)
      pst.str(string("            BC "))
      
     repeat
      exSum:=0
      exRnd++
      repeat exI from 1 to 62
         BCbuf1[exI]:=exI+100
         exSum:=exSum+BCBuf1[exI]         
      typebuffer(@BCBuf1,0,62)
      pst.str(string(" <<< ")) 
      waitcnt(clkfreq/VALID_DELAY + cnt)
      BCBuf1[0]:=1 ' command=send param
      waitcnt(clkfreq/VALID_DELAY + cnt)
      bc.SendCommand(1)

      repeat
         bc.SendCommand(2)
         waitcnt(clkfreq/VALID_DELAY + cnt)
      until BCBuf2[0]==2
      typebuffer(@BCBuf2,0,62)
      pst.str(string(" <<< ")) 
      waitcnt(clkfreq/VALID_DELAY + cnt)


      repeat exI from 1 to 62
         BCbuf1[exI]:=BCbuf2[exI]+100
         exSum:=exSum+BCBuf1[exI]         
      typebuffer(@BCBuf1,0,62)
      pst.str(string(" <<< ")) 
      waitcnt(clkfreq/2 + cnt)
      BCBuf1[0]:=3 ' command=send param
      waitcnt(clkfreq/VALID_DELAY + cnt)
      bc.SendCommand(1)

      repeat
         bc.SendCommand(2)
         waitcnt(clkfreq/VALID_DELAY + cnt)
      until BCBuf2[0]==4
      typebuffer(@BCBuf2,0,62)
      pst.str(string(" <<< ")) 
      waitcnt(clkfreq/VALID_DELAY + cnt)
      pst.dec(exRnd)
      if exsum==28706
      else    
         pst.dec(exSum)
         pst.char("|")
         pst.dec(exRnd)
         repeat
      
     
        

pri execRT | exI, exSum, exRnd

'---------------------------------------------------------------------------    

    pst.start(115200)
    pst.str(@NEWLINE)
    pst.str(string("              RT "))
    
   repeat
    exRnd++
    exSum:=0
    repeat until RTBuf[0]==1
    typebuffer(@RTBuf,0,62)
    pst.str(string(" <<< "))
    'waitcnt(clkfreq/VALID_DELAY + cnt)
    
    repeat exI from 1 to 62
      RTbuf[exI]:=RTBuf[exI]+100
      exSum:=exSum+RTBuf[exI]
    typebuffer(@RTBuf,0,62)
    RTBuf[0]:=2

    repeat until RTBuf[0]==3
      typebuffer(@RTBuf,0,62)
    pst.str(string(" <<< "))
    'waitcnt(clkfreq/VALID_DELAY + cnt)
    
    repeat exI from 1 to 62
      RTbuf[exI]:=RTBuf[exI]+100
      exSum:=exSum+RTBuf[exI]
    typebuffer(@RTBuf,0,62)
    RTBuf[0]:=4
    pst.dec(exRnd)
    if exsum==41106
    else    
         pst.dec(exSum)
         pst.char("|")
         pst.dec(exRnd)
         repeat
      

    
     

 
pri typebuffer(bufadr,start,end)|typeJ

    repeat typeJ from start to end
        pst.dec(word[bufadr][typeJ])        
        pst.char(";")
             
 
pri startBC

          bc.AddBuffer(1, @BCBuf1, BUF_SIZE, bc#TRANSMIT_BUFFER)   ' ctrl1
          bc.AddBuffer(2, @BCBuf2, BUF_SIZE, bc#RECEIVE_BUFFER)
          bc.AddBuffer(3, @BCBuf3, BUF_SIZE, bc#RECEIVE_BUFFER)
          bc.AddBuffer(4, @BCBuf4, BUF_SIZE, bc#TRANSMIT_BUFFER)   ' ctrl2
          bc.AddBuffer(5, @BCBuf5, BUF_SIZE, bc#RECEIVE_BUFFER)
          bc.AddBuffer(6, @BCBuf6, BUF_SIZE, bc#RECEIVE_BUFFER)
          bc.SetBitRate(BUS_BIT_RATE)

          ' Single Wire
          bc.Start(3, 3, -1, CYCLE_FREQ, MSG_COUNT) ' 1 wire p3 master


pri startRT  ' RTno >=1

  rt.AddBuffer(1, @RTBuf  , BUF_SIZE, rt#RECEIVE_BUFFER)
  rt.AddBuffer(2, @RTBuf  , BUF_SIZE, rt#TRANSMIT_BUFFER)
  rt.AddBuffer(3, @IncrBuf, BUF_SIZE, rt#TRAN_INCR_BUFFER)
  rt.SetBitRate(BUS_BIT_RATE)

  ' Single Wire
  rt.Start(9, 9, -1, 0 ) '1wire p9
       